# coding: utf-8
from rest_framework.request import Request
from datetime import datetime, timedelta
from inspect_report.models import Tasks, CheckSession, RulesStat
from config.config import TABLE_PRE
import json
import logging
"""定时任务

参考：https://github.com/jgorset/django-kronos
"""
logger = logging.getLogger("app_file")


def rule_stat(start_date, end_date):
    """
    首页概述-违规项统计
    :return:
    """
    task_condition = {'hasCheck': 1, 'createdAt__gte': start_date, 'createdAt__lt': end_date}
    tasks = Tasks.objects.filter(**task_condition).values('id', 'name', 'sessionCollectionId')
    stat_count = 0
    for t in tasks:
        return_data = {}
        table_name = TABLE_PRE + t['sessionCollectionId']
        tn = CheckSession.set_table(table_name)
        session_condition = {'taskId': t['id'], 'violationRuleCount__gt': 0}
        checks = tn.objects.filter(**session_condition).values('id', 'checkResult')
        for check in checks:
            result = check['checkResult']
            if result:
                data = json.loads(result)
                for d in data:
                    if 'isViolation' in d.keys() and d['isViolation'] and 'rule' in d.keys() and 'name' in d['rule'].keys():
                        name = d['rule']['name']
                        if name in return_data.keys():
                            return_data[name]['count'] += 1
                        else:
                            return_data[name] = {'count': 1}
        for m, n in return_data.items():
            rd = RulesStat()
            rd.create_date = start_date
            rd.from_table = t['sessionCollectionId']
            rd.rule_name = m
            rd.rule_num = n['count']
            rd.area = t['name'].split('_')[0]
            rd.save()
            stat_count += 1
            logger.info('统计数量为：%s' % stat_count)

